# merge portal installation
---

# key generation ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
- hosts: px0
  become: true
  tasks:
    - name: generate keys
      include_role:
        name: keygen
      tags:
        - keygen

# database setup ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
- hosts: db0
  become: true
  tasks:
    - name: run db setup
      include_role:
        name: db
      vars:
        etcd_index: 0
        mariadb_index: 1
        master: true
      tags:
        - db

- hosts: db1
  become: true
  tasks:
    - name: run db setup
      include_role:
        name: db
      vars:
        etcd_index: 1
        mariadb_index: 2
        master: false
      tags:
        - db

- hosts: db2
  become: true
  tasks:
    - name: run db setup
      include_role:
        name: db
      vars:
        etcd_index: 2
        mariadb_index: 3
        master: false
      tags:
        - db

# elastic setup ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
- hosts: [db0, db1, db2]
  become: true
  strategy: free
  tasks:

    - name: elastic search and kibana setup
      include_role:
        name: elastic
      tags:
        - db

# k8s-master setup ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

- hosts: [ma0, ma1, ma2]
  become: true
  strategy: free

  tasks:
    - name: run k8s-master setup
      include_role: 
        name: k8s-master
      tags:
        - k8m

# haproxy setup ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

- hosts: [px0, px1]
  become: true
  tasks:
    - name: setup haproxy
      include_role:
        name: haproxy
      tags:
        - haproxy


# TODO(ry) replicate maxscale on px1 for failover
# maxscale setup ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

- hosts: px0
  become: true
  tasks:
    - name: setup maxscale
      include_role:
        name: maxscale
      tags:
        - maxscale
      
# k8s-node setup ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

# add hosts here as needed 
# or add after the fact with kn-add.yml
- hosts: [kn0, kn1, kn2, kn3]
  become: true
  strategy: free

  tasks:
    - name: run k8s-node setup
      include_role: 
        name: k8s-node
      tags:
        - k8n

# administrator setup

- hosts: db0
  become: true
  tasks:
    - name: initialize administrator
      include_role:
        name: merge-init
      tags:
        - merge-init

